import React,{Component} from "react";
import {View,Text} from '@tarojs/components'
import Taro from '@tarojs/taro';
import { AtIcon,AtNoticebar  } from 'taro-ui'
import './index.less';
import  {getPublicReleaseUnread} from '../../../utils/servers/servers';

import "taro-ui/dist/style/components/icon.scss";
import "taro-ui/dist/style/components/noticebar.scss";

class MessageNoticebar extends Component{
  constructor(props) {
    super(props);
    this.state={
      animationData:{},
      isOpend:false,
      str:''
    }
    this.onClose = this.onClose.bind(this);
    this.getPublicReleaseUnread = this.getPublicReleaseUnread.bind(this);
    this.close = this.close.bind(this);
  }

  componentWillMount () {
    let animation = Taro.createAnimation({
      duration: 1000,
      timingFunction: 'ease',
    })

    this.animation = animation

    this.setState({
      animation:animation.export()
    })


    Taro.eventCenter.on('GoPuncsshIn', (data) => {
      if(data.data === 'unread'){
        this.getPublicReleaseUnread();
      }
    })

    Taro.eventCenter.on('closeMessageNoticebar', () => {
      this.close();
    })

    Taro.eventCenter.on('getMessageNoticebar', (data) => {
      this.setState({
        str:data
      },()=>{
        this.animation.opacity(1).step()
        this.setState({
          animation: this.animation.export(),
          isOpend:true
        })
      })
    })
  }

  onClose(){
    Taro.eventCenter.trigger('closeMessageNoticebar');
  }

  close(){
    this.animation.opacity(0).step()
    this.setState({
      animation: this.animation.export(),
      isOpend:false,
      str:''
    })
  }

  getPublicReleaseUnread(){
    getPublicReleaseUnread({}).then(v=>{
      if(v.error.length === 0){
        if(v.data.length === 0){return;}
        let str = '';
        for(let i of v.data){
          str+=i.content+'\n'
        }
        Taro.eventCenter.trigger('getMessageNoticebar',str);
      }else{
        Taro.showToast({title:v.error[0].message,icon:'none'})
      }
    }).catch(()=>{
      Taro.showToast({
        title:'系统错误,请稍后再试',
        icon:'none'
      })
    })
  }

  render() {
    return (
      <View className='messageNoticebar' animation={this.state.animation}>
        {this.state.isOpend ? <View className='content'>
              <View style={{width:'100%'}}>
                <AtNoticebar speed='50' icon='volume-plus'>
                  <Text decode>
                    {this.state.str}
                  </Text>
                </AtNoticebar>
              </View>
              <View className='noticebar' onClick={this.onClose}>
                <AtIcon value='close' size='10'/>
              </View>
        </View> : null}
      </View>
    )
  }
}

export default MessageNoticebar;
