import React,{Component} from "react";
import {AtCalendar, AtModal, AtModalAction, AtModalContent} from "taro-ui";
import {Button} from "@tarojs/components";
import Enterprise from './enterprise';
import PublicContent from './publicContent';

import {updatePublicRelease} from '../../utils/servers/servers';

import 'taro-ui/dist/style/components/modal.scss';
import Taro from "@tarojs/taro";

class Modify extends Component{
  constructor(props) {
    super(props);
    this.state={
      data:{}
    }
    this.submit = this.submit.bind(this);
    this.onChange = this.onChange.bind(this);
  }

  submit(){
    if(Object.keys(this.state.data).length === 0){
      this.props.onClose();
      return;
    }
    updatePublicRelease({
      id:this.props.id,
      ...this.state.data
    }).then(v=>{
      if(v.error.length === 0){
        Taro.showToast({title:'修改成功'});
        Taro.eventCenter.trigger('listOperation',{
          type:this.props.type,
          status: 1,
          index:this.props.index
        })
        this.props.onClose();
      }else{
        Taro.showToast({title:v.error[0].message,icon:'none'})
      }
    }).catch(err=>{
      Taro.showToast({title:'系统错误.请稍后重试',icon:'none'})
      console.log(err)
    })

  }

  componentWillReceiveProps(props){
    if(!props.isOpened){
      this.setState({
        data:{}
      })
    }
  }

  onChange(value){
    this.setState({
      data:value
    })
  }

  render() {
    return (
      <AtModal isOpened={this.props.isOpened} onClose={this.props.onModalClose}>
        <AtModalContent>
          {
            this.props.modifyType === 1 ?
              <Enterprise isOpened={this.props.isOpened} onChange={this.onChange}/> :
              <PublicContent
                type={this.props.type}
                index={this.props.index}
                onClose={()=>{
                  this.props.onClose();
                }}
                locationInfor={this.props.locationInfor}
                dtails={this.props.dtails}
                isOpened={this.props.isOpened}
                onChange={this.onChange}
              />
          }
        </AtModalContent>
        {
          this.props.modifyType === 1 ?
            <AtModalAction>
              <Button onClick={()=>{
                this.props.onClose();
              }}>
                取消
              </Button>
              <Button onClick={this.submit}>
                确定
              </Button>
            </AtModalAction>:
            null
        }
      </AtModal>
    )
  }
}

export default Modify;
